# Modbus2HA

Ein einfacher Adapter um Modbus-Daten ins Home Assistant zu bekommen.

## Übersicht

Der Adapter besteht aus einer kleinen Platine mit einigen wenigen Bauteilen sowie der Firmware die über [ESPHome](https://esphome.io/index.html) generiert wird. Wie man ESPHome einrichtet (zB. Lokal oder auf einem Docker-Host) wird hier nicht weiter beschrieben. Dazu sollen sich aber leicht Anleitungen im Internet finden lassen.

## Hardware

### Bauteile

Benötigt werden folgende Bauteile (Preise pro Stück und ohne Porto; bei einigen Shops muss man aber direkt mehrere Teile bestellen). In der Summe sollte der Adapter für ca. 20 EUR zu bekommen sein (weniger wenn man mehr in China bestellt oder ggfs. Teile schon vorrätig hat).

| Bauteil      | Bezugsquelle | ca. Preis
|--------------|--------------|----------
| ESP-32 30PIN | [AliExpress](https://de.aliexpress.com/item/1005006018016908.html?spm=a2g0o.order_list.order_list_main.39.2dbe5c5fJ8Wlww&gatewayAdapt=glo2deu) |   4,00 EUR       |
| RS232->RS485 Adapter | [Amazon](https://www.amazon.de/dp/B09VGJCJKQ?psc=1&ref=ppx_yo2ov_dt_b_product_details) | 1,40 EUR
| RJ45 Buchse  | [Amazon](https://www.amazon.de/gp/product/B07BQK2LVH/ref=ppx_yo_dt_b_search_asin_title?ie=UTF8&psc=1) | 1,00 EUR
| 2x Jumper    | [Reichelt](https://www.reichelt.de/kurzschlussbruecke-rot-mit-grifflasche-jumper-2-54gl-rt-p9018.html?&trstct=pol_3&nbc=1) | 0,04 EUR
| Stiftleisten 2-Reihig | [Reichelt](https://www.reichelt.de/2x40pol-stiftleiste-gerade-rm-2-54-sl-2x40g-2-54-p19498.html?&trstct=pol_0&nbc=1) | 0,10-0,20 EUR
| Buchsenleiste, trennbar | [Reichelt](https://www.reichelt.de/buchsenleiste-2-54mm-1x20-trennbar-verzinnt-fis-bl1-20-z-p283794.html?&trstct=pos_1&nbc=1) | 1,45 EUR
| Abstandsbolzen | [Reichelt](https://www.reichelt.de/raspberry-pi-abstandshalter-sortiment-m2-5-rpi-mountingkit4-p223625.html?&trstct=vrt_pdn&nbc=1) | 0,20 cent
| Abzweigose | lokaler Baumarkt | 1,00 EUR
| Platine    | siehe unten      | 2,00 EUR

Die Stift-und Buchsenleiste kann man gut in größerer Menge kaufen da sie immer mal wieder nützlich sind. Da sie trennbar sind kürzt man sie dann einfach auf die benötigte Länge.

### Platine

Die Gerber-Files zu bestellen können [hier in dem Git-Repo](https://git.un-hack-bar.de/UNHB/Modbus2HA/raw/branch/main/PCB/Gerber_MODBUS2HA_PCB_v2.zip) runtergeladen werden. Mit den Files kann bei einem entsprechenden Dienstleister (z.B. [JLCPCB](https://jlcpcb.com/)) die Platine bestellt werden.

### Aufbau

| Schritt       | Bild |
|---------------|------|
| Benötigte Teile besorgen und zusammenlegen | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_102800.jpg">
| Zuerst die Stift- bzw. Buchsenleisten sowie die RJ45 Buchse anlöten. Für den RS485-Adapter haben ich einfach bei einer Buchsenleitste mit 5 Pins den zweiten und vierten Anschluss mit einem Seitenschneider abgekniffen.<br>&nbsp;<br>**Wichtig:** Am besten zuerst die Stift- und Buchsenleisten zusammenstecken und dann den ESP32 und und die Platine zusammenstecken. Im Anschluss alles anlöten. So kann man relativ leicht sicherstellen, dass die Leisten wirklich die passenden Abstände haben damit am Ende alles zu zusammenpasst.   | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_102916.jpg">
| Mit der Platine als Schablone die Löcher markieren und anschließend mit einem 2mm Bohrer Löcher reinbohren.     | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_103627.jpg">
| Die Abstandsbolzen reinschraubn und außen mit Muttern fixieren     | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_104240.jpg">
| Die Platine auf die Bolzen legen, die Aussparungen für die RJ5- und USB-Buchse markieren und entsprechend ausschneiden.       | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_105629.jpg">
| Die Platine mit Schrauben an die Bolzen befestigen.     | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_110543.jpg">
| Die Jumger entsprechend der Modbus-Kabelbelegung setzen.  | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_110550.jpg">
| Fertig!       | <img width="500" src="/UNHB/Modbus2HA/raw/branch/main/Images/20240211_111642.jpg">

**Wichtig**: Es gibt keinen Kurzschluss-Schutz! Wenn beide Jumper auf die gleichen Pins gesetzt werden (z.B. beide ganze oben) werden A+ und B- kurzgeschlossen. Das sollte den Modbus nicht zerstören aber natürlich kann so keine Kommunikation stattfinden.

Der Jumper für GND kann und sollte offen gelassen werden. 

## Software

Als Software verwende ich eine .yaml Konfiguration für ESPHome. Die Datei sollte etwas angepasst werden. Insbesondere:
- WLAN Zugangsdaten
- Home Assistant API Key
- OTA Kennwort

Außerdem müssen natürlich die "Sensoren" entsprechend der Modbus-Adressen die ins Home Assistant gehen sollen angelegt werden.